<cfapplication name="cfimage_presentation" sessionmanagement="false">

<cfif NOT IsDefined("application.root_path")>
	<cfset application.root_path = ExpandPath("./")>
</cfif>

<!--- normally you wouldn't want to put this in application.cfm but I will be using it in a lot of the examples--->
<cffunction name="uploadPhoto" returntype="string" hint="uploads a photo from a form field and returns the filename">
	<cfargument name="filefield" type="variablename" default="photo" hint="the form field that contains the photo">
	<cfargument name="destination" default="#application.root_path#uploaded-images/">
	<cfargument name="allowed_extensions" default="gif,jpg,jpeg,png" type="string">
	<cfargument name="name_conflict" type="variablename" default="makeunique">
	<cfset var temp_dir = GetTempDirectory()>
	<cfset var file_name = "">
	<cfif NOT StructKeyExists(form, arguments.filefield)>
		<cfthrow message="filefield is not defined.">
	</cfif>
	<cffile action="upload" filefield="photo" accept="image/jpg,image/jpeg,image/gif,image/png" nameconflict="#arguments.name_conflict#" destination="#temp_dir#">
	<cfif NOT ListFindNoCase(arguments.allowed_extensions, cffile.ClientFileExt) OR NOT ListFindNoCase(arguments.allowed_extensions, cffile.ServerFileExt)>
		<!--- this is why we uploaded to a temp dir so they can't execute it before we delete it--->
		<cffile action="delete" file="#cffile.ServerDirectory#/#cffile.ServerFile#">
		<cfthrow message="Sorry file type not allowed.">
	</cfif>
	<cfif NOT DirectoryExists(arguments.destination)>
		<cfthrow message="Destination directory does not exist.">
	</cfif>
	<cfset file_name = LCase(cffile.ServerFile)>
	<cfif LCase(arguments.name_conflict) IS "makeunique">
		<cfloop condition="#FileExists(arguments.destination & file_name)#">
			<cfset file_name = RandRange(100,999) & "-" & file_name>
		</cfloop>
	</cfif>
	<cffile action="move" source="#cffile.ServerDirectory#/#cffile.ServerFile#" destination="#arguments.destination##file_name#">
	<cfreturn file_name>
</cffunction>

<!--- don't recommend this either but it makes the code examples less cluttered --->
<html>
	<head>
		<title>CFImage Examples</title>
		<style type="text/css">
			body { font-family: "Lucida Grande", verdana; }
			label { width: 130px; position:absolute; }
			input { margin-left: 145px; display:block; }
		</style>
	</head>
	<body>
	
	